import java.io.File;
import java.io.FileReader;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;

import java.util.HashMap;
import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.Scanner;
import java.util.NoSuchElementException;

/**
 * Q[ubN
 */
public class GameBook {

	/** t@Ceꗗ */
	private			HashMap<String, ArrayList<String>>		mapGame			= null;

	/** eLXgXLi */
	private			Scanner									scanner			= null;

	/**
	 * n܂܂B
	 */
	public static void main(String[] args){

		try{

			// 
			GameBook app = new GameBook();

			// Q[Jn
			app.run("000");

		}catch(NoSuchElementException ee){

			System.out.println("Q[̓ełBNo,em,No,eEEEňJԂɂȂĂ邩AmFĂ");
			ee.printStackTrace();

		}catch(FileNotFoundException fe){

			System.out.println("t@CI[vO");
			fe.printStackTrace();

		}catch(IOException ie){

			System.out.println("o͗O");
			ie.printStackTrace();

		}

	} // end main

	/**
	 * RXgN^
	 */
	public GameBook() throws FileNotFoundException, IOException {

		// ݂̃pX擾
		String strPath = new File(".").getAbsoluteFile().getParent();

		// t@C
		String strFile = "GameBook.txt";

		// t@CpX쐬
		String strPathFile = strPath + File.separator + strFile;

		// [_[𐶐
		BufferedReader br = new BufferedReader(new FileReader(strPathFile));

		// t@Ceꗗ𐶐
		mapGame = new HashMap<String, ArrayList<String>>();

		// t@CI܂ŁA[v
		while(true){

			// s擾
			String strLine = br.readLine();

			// t@CǂݏI
			if(strLine == null){
				// [v𔲂
				break;
			}

			// g[N
			StringTokenizer st = new StringTokenizer(strLine);

			// No
			String strNo = st.nextToken();

			// bZ[W
			String strMessage = st.nextToken();

			// e
			ArrayList<String> dataLst = new ArrayList<String>(5);

			// eɃbZ[Wǉ
			dataLst.add(strMessage);

			// IA[v
			while(true){

				// ̃g[N݂ȂꍇA
				if(!st.hasMoreTokens()){
					// [v𔲂
					break;
				}

				// NoiIj
				String strNoSelect = st.nextToken();

				// bZ[WiIj
				String strMessageSelect = st.nextToken();

				// eɒǉ
				dataLst.add(strNoSelect);
				dataLst.add(strMessageSelect);

			} // end while IA[v

			// t@Ceꗗɒǉ
			mapGame.put(strNo, dataLst);

		} // end while t@CI܂ŁA[v

		// [_[N[Y
		br.close();

		// XLi𐶐
		scanner = new Scanner(System.in);

	} // end GameBook

	/**
	 * Q[
	 * @param strNo ԍ
	 */
	private void run(String strNo){

		// s
		newLine();

		// e擾
		ArrayList<String> dataLst = mapGame.get(strNo);

		// CfbNX
		int index = 0;

		// bZ[W擾
		String strMessage = dataLst.get(index);

		// bZ[W\
		print(strMessage);

		// s
		newLine();

		// Iꗗ𐶐
		ArrayList<String> strSelectLst = new ArrayList<String>(2);

		// I[v
		while(true){

			// CfbNX{P
			index++;

			// vf݂ȂꍇA
			if(index >= dataLst.size()){
				// [v𔲂
				break;
			}

			// NoiIj
			String strNoSelect = dataLst.get(index);

			// Q[I[o[̏ꍇA
			if(strNoSelect.equals("GAMEOVER")){
				// VXeI
				System.exit(0);
			}

			// Iꗗɒǉ
			strSelectLst.add(strNoSelect);

			// CfbNX{P
			index++;

			// bZ[WiIj
			String strMessageSelect = dataLst.get(index);

			// bZ[W\
			print(strMessageSelect + " -> " + strNoSelect);

		} // end while I[v

		// s
		newLine();

		// I܂Ń[v
		while(true){

			// I擾
			String strSelect = scanner.next();

			// No擾i[pfBOj
			strSelect = getNo(strSelect);

			// null̏ꍇA
			if(strSelect == null){
				// bZ[W\
				print("IIIԈĂ܂II");
				// ReBj[
				continue;
			}

			// IƂđ݂ꍇA
			if(strSelectLst.contains(strSelect)){
				// VNo
				this.run(strSelect);

			// IƂđ݂ȂꍇA
			}else{
				// bZ[W\
				print("IIIԈĂ܂II");
				// ReBj[
				continue;
			}

		} // end while I[v

	} // end run

	/**
	 * s
	 */
	private void newLine() {
		System.out.println("");
	}

	/**
	 * \
	 */
	private void print(String strData) {
		System.out.println(strData.replace("\\n", "\n"));
	}

	/**
	 * No擾i[pfBOj
	 * <pre>
	 * ͕s\ȏꍇ́AnullԂ܂B
	 * </pre>
	 */
	private String getNo(String strNo){

		try{

			// intɒu
			int no = Integer.parseInt(strNo);

			// String^ɒu
			String strNo1 = "00" + String.valueOf(no);
			strNo1 = strNo1.substring(strNo1.length() - 3);

			// ^[
			return strNo1;

		}catch(NumberFormatException nfe){
			// nullŃ^[
			return null;
		}

	} // end getNo

}
